# This code is part of Qiskit.
#
# (C) Copyright IBM 2022.
#
# This code is licensed under the Apache License, Version 2.0. You may
# obtain a copy of this license in the LICENSE.txt file in the root directory
# of this source tree or at http://www.apache.org/licenses/LICENSE-2.0.
#
# Any modifications or derivative works of this code must retain this
# copyright notice, and modified files need to carry a notice indicating
# that they have been altered from the originals.

"""
The Watson Hamiltonian (:mod:`qiskit_nature.second_q.formats.watson`)
=====================================================================

.. currentmodule:: qiskit_nature.second_q.formats.watson

.. autosummary::
   :toctree: ../stubs/
   :nosignatures:


   WatsonHamiltonian

"""

from .watson_hamiltonian import WatsonHamiltonian

__all__ = [
    "WatsonHamiltonian",
]
